import java.awt.*;
import java.util.Enumeration;
import jds.Stack;
import jds.collection.LinkedList;

public class Hanoi extends Frame {
	static public void main (String [ ] args) 
		{ Hanoi world = new Hanoi(); world.show(); world.run(); }

	public Hanoi () { setSize (400, 200); setTitle("Towers of Hanoi"); }

	public void run () {
			// put initial disks on stack one
		int size = 10;
		for (int i = size; i > 0; i--)
			one.addLast(new Integer(i));
			// now solve puzzle
		solveHanoi(size, one, two, three);
	}

	private Stack one = new LinkedList();
	private Stack two = new LinkedList();
	private Stack three = new LinkedList();

	public void paint (Graphics g) {
		paintStack(one, g, 100, 180);
		paintStack(two, g, 200, 180);
		paintStack(three, g, 300, 180);
	}

	private void paintStack(Stack stk, Graphics g, int x, int y) {
		Enumeration e = stk.elements();
		while (e.hasMoreElements()) {
			Integer disk = (Integer) e.nextElement();
			int size = disk.intValue();
			g.fillRect(x - 4 * size, y, 8 * size, 10);
			y = y - 10;
		}
	}

	private void solveHanoi (int n, Stack a, Stack b, Stack c) {
		if (n > 0) {
			solveHanoi(n-1, a, c, b);
				// move one disk
			Object disk = a.getLast();
			a.removeLast();
			b.addLast(disk);
				// then repaint
			repaint();
			try {
				Thread.sleep(200);
			} catch(Exception e) { }
			solveHanoi(n-1, c, b, a);
		}
	}
}

