import java.awt.*;

import jds.Set;
import jds.Queue;
import jds.util.IntegerCompare;
import jds.util.TaskTimer;
import jds.util.Reporter;
import jds.util.GraphMaker;
import jds.collection.IndexedDeque;
import jds.collection.LinkedList;

class QueueTester extends TaskTimer {
	private Queue que;

	public QueueTester (Reporter rep, Queue q) {
		super(rep);
		que = q; value = new Integer(42); 
	}

	private Object value;

	public void doTask (int n) {
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < 10; j++)
				que.addLast(value);
			for (int j = 0; j < 10; j++)
				que.removeFirst();
		}
	}

	public void doTaskTwo (int n) {
		for (int i = 0; i < n; i++) {
			que.addLast(value);
		}
		for (int i = 0; i < n; i++) {
			que.removeFirst();
		}
	}
}

public class QueueExperiment extends Frame {

	public static void main (String [ ] args) {
		QueueExperiment world = new QueueExperiment();
		world.show(); world.run(); 
	}

	public QueueExperiment () {
		setTitle("Queue Experiment 1");
		setSize(500, 300);
		add("Center", graph);
	}

	private GraphMaker graph = new GraphMaker(10000, 2500);

	public void run () {
		QueueTester t1 = new QueueTester(graph.getReporter("Deque"), 
				new IndexedDeque());
		t1.run(0, 10000, 200);
		QueueTester t2 = new QueueTester(graph.getReporter("List"), 
				new LinkedList());
		t2.run(0, 10000, 200);
	}
}

