import java.awt.*;
import jds.util.TaskTimer;
import jds.util.Reporter;
import jds.util.GraphMaker;
import jds.collection.LinkedList;
import jds.collection.SelfOrgList;

class SelfTest extends TaskTimer {

	public SelfTest (Reporter rep) {
		super(rep);
	}

	public void initialize (int n) {
		lst = new SelfOrgList();
		lst.addElement(new Integer(42));
		for (int i = 0; i < n; i++) {
			lst.addElement(new Integer((int) (1000 * Math.random())));
			}
	}

	LinkedList lst;

	public void doTask (int n) {
		for (int i = 0; i < n; i++) {
			if ((i % 7) == 0)
				lst.containsElement(new Integer(42));
			else
			lst.containsElement(
				new Integer((int) (1000 * Math.random())));
			}
	}
}

class SelfTest2 extends TaskTimer {

	public SelfTest2 (Reporter rep) {
		super(rep);
	}

	public void initialize (int n) {
		lst = new LinkedList();
		lst.addElement(new Integer(42));
		for (int i = 0; i < n; i++) {
			lst.addElement(new Integer(
				(int) (1000 * Math.random())));
			}
	}

	LinkedList lst;

	public void doTask (int n) {
		for (int i = 0; i < n; i++) {
			if ((i % 7) == 0)
				lst.containsElement(new Integer(42));
			else
			lst.containsElement(new Integer(
				(int) (1000 * Math.random())));
			}
	}
}

public class SelfOrgExperiment extends Frame {

	public static void main (String [ ] args) {
		SelfOrgExperiment world = new SelfOrgExperiment();
	}

	public SelfOrgExperiment () {
		setTitle("Self Organizing List Experiment");
		setSize(500, 300);
		GraphMaker graph = new GraphMaker(5000, 5000);
		add("Center", graph);
		show();

		SelfTest t1 = new SelfTest(graph.getReporter("Self Org"));
		t1.run(200, 4500, 200);
		SelfTest2 t2 = new SelfTest2(graph.getReporter("List"));
		t2.run(200, 2000, 200);
	}
}

