import java.awt.*;

import jds.Bag;
import jds.util.IntegerCompare;
import jds.util.TaskTimer;
import jds.util.Reporter;
import jds.util.GraphMaker;
import jds.util.IntegerCompare;
import jds.collection.AVLTree;
import jds.collection.SetAdapter;

class SetTester1 extends TaskTimer {

	public SetTester1 (Reporter rep) {
		super(rep);
	}

	public void doTask (int n) {
		Bag stk = new AVLTree(new IntegerCompare());
		for (int i = 0; i < n; i++) {
			stk.addElement(new Integer((int) (n * Math.random())));
		}
	}
}

class SetTester2 extends TaskTimer {

	public SetTester2 (Reporter rep) {
		super(rep);
	}

	public void doTask (int n) {
		Bag stk = new SetAdapter(new AVLTree(new IntegerCompare()));
		for (int i = 0; i < n; i++) {
			stk.addElement(new Integer((int) (n * Math.random())));
		}
	}
}

public class SetExperiment extends Frame {

	public static void main (String [ ] args) {
		SetExperiment world = new SetExperiment(); world.show(); world.run(); }

	public SetExperiment () {
		setTitle("Set Time Comparison Experiment");
		setSize(500, 300);
		add("Center", graph);
	}

	private GraphMaker graph = new GraphMaker(10000, 2500);

	public void run () {
		SetTester1 t1 = new SetTester1(graph.getReporter("AVLTree"));
		t1.run(0, 9500, 200);
		SetTester2 t2 = new SetTester2(graph.getReporter("SetAdapter"));
		t2.run(0, 8000, 200);
	}
}

