import jds.collection.BitSet;

class Sieve {
	public BitSet sieve (int n) {
		BitSet values = new BitSet(n);
			// mark all values as on
		for (int i = 2; i < n; i++)
			values.set(i);

			// now search for non-zero cells
		for (int i = 2; i*i <= n; i++) {
			if (values.get(i)) {
				// inv: i has no factors
				for (int j = i + i; j < n; j+= i)
					values.clear(j);
				// inv: multiples of i have been cleared
			}
			// inv: all marked values amller than i are prime
		}
		// inv: all marked values are prime
		return values;
	}

	public static void main (String [ ] args) {
		Sieve s = new Sieve();
		BitSet p = s.sieve(300);
		for (int i = 0; i < 300; i++)
			if (p.get(i))
				System.out.println("prime: " + i);
	}
}

