//
//	Silly Sentence Generation Program
//	written by Timothy A. Budd, September 1999
//	appears in Data Structures in Java
//	published by Addison-Wesley
//

import java.io.*;
import jds.collection.Vector;

class SillySentence {
	static public void main (String [ ] args) { new SillySentence(); }

	SillySentence () {
		Vector subjects = readFromFile("subject");
		Vector verbs = readFromFile("verb");
		Vector objects = readFromFile("object");
		for (int i = 0; i < 5; i++) 
			System.out.println(randomElement(subjects) + " "  +
				randomElement(verbs) + " " + 
				randomElement(objects));
	}

	private Vector readFromFile (String fileName) {
		Vector result = new Vector();
		try {
			FileReader fin = new FileReader(fileName);
			BufferedReader din = new BufferedReader(fin);
			String line = din.readLine();
			while (line != null) {
				result.addLast(line);
				line = din.readLine();
			}
		} catch (IOException e) { }
		return result;
	}

	private String randomElement (Vector v) {
		int index = (int) (v.size() * Math.random());
		return (String) v.elementAt(index);
	}
}

