import java.io.*;
import java.util.*;
import jds.Map;
import jds.collection.*;
import jds.collection.Vector;

class SillySentence2 {
	protected Map rules = new MapAdapter(new LinkedList());

	public SillySentence2 (BufferedReader input) throws IOException {
		while (true) {
			String text = input.readLine();
			if (text == null) return;
			Enumeration e = new StringTokenizer(text);
			LinkedList rule = new LinkedList();
			while (e.hasMoreElements())
				rule.addLast(e.nextElement());
			String category = (String) rule.getFirst();
			rule.removeFirst();
			if (! rules.containsKey(category))
				rules.set(category, new Vector());
			Vector v = (Vector) rules.get(category);
			v.addLast(rule);
		}
	}

	public String generateString (String start) {
		if (rules.containsKey(start)) {
			Vector v = (Vector) rules.get(start);
			int i = (int) (v.size() * Math.random());
			LinkedList rule = (LinkedList) v.elementAt(i);
			String result = "";
			Enumeration e = rule.elements(); 
			while (e.hasMoreElements())
				result = result + generateString(
					(String) e.nextElement());
			return result;

		} 
		return start + " "; // add padding at end
	}

	public static void main (String [ ] args) {
		try {
			FileReader f1 = new FileReader(args[0]);
			SillySentence2 grammar = new SillySentence2(
				new BufferedReader(f1));
			System.out.println(grammar.generateString("SENTENCE"));
		} catch (Exception e) { System.err.println("got exception" + e); }
	}
}
