import java.awt.*;

import jds.Set;
import jds.util.IntegerCompare;
import jds.util.TaskTimer;
import jds.util.Reporter;
import jds.util.GraphMaker;
import jds.util.CloseQuit;
import jds.collection.SortedVector;
import jds.collection.SortedList;
import jds.collection.SkipList;

class SetInsert extends TaskTimer {

	public SetInsert (Reporter rep) { super(rep); }

	public void initialize (int n) {
		sk = new SkipList(new IntegerCompare());
	}

	SkipList sk;

	public void doTask (int n) {
		for (int i = 0; i < n; i++) {
			sk.addElement(new Integer(
				(int) (1000 * Math.random())));
			}
	}
}

class Set2Insert extends TaskTimer {

	public Set2Insert (Reporter rep) { super(rep); }

	public void initialize (int n) {
		sk = new SortedList(new IntegerCompare());
	}

	SortedList sk;

	public void doTask (int n) {
		for (int i = 0; i < n; i++) {
			sk.addElement(new Integer(
				(int) (1000 * Math.random())));
			}
	}
}

class Set3Insert extends TaskTimer {

	public Set3Insert (Reporter rep) { super(rep); }

	public void initialize (int n) {
		sk = new SortedVector(new IntegerCompare());
	}

	SortedVector sk;

	public void doTask (int n) {
		for (int i = 0; i < n; i++) {
			sk.addElement(new Integer(
				(int) (1000 * Math.random())));
			}
	}
}

public class SkipExperiment extends Frame {

	public static void main (String [ ] args) {
		SkipExperiment world = new SkipExperiment();
	}

	public SkipExperiment () {
		setTitle("SkipList Insertion Experiment");
		setSize(500, 300);
		addWindowListener(new CloseQuit());
		GraphMaker graph = new GraphMaker(10000, 2500);
		add("Center", graph);
		show();

		SetInsert t1 = new SetInsert(graph.getReporter("Skip"));
		t1.run(200, 10000, 200);
		Set2Insert t2 = new Set2Insert(graph.getReporter("SortedList"));
		t2.run(200, 2100, 100);
	}
}

