import java.awt.*;

import jds.Stack;
import jds.util.IntegerCompare;
import jds.util.TaskTimer;
import jds.util.Reporter;
import jds.util.GraphMaker;
import jds.collection.IndexedDeque;
import jds.collection.Vector;

class StackTester extends TaskTimer {
	private Stack stk;

	public StackTester (Reporter rep, Stack s) {
		super(rep);
		stk = s;
		value = new Integer(42); 
	}

	private Object value;

	public void doTask (int n) {
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < 10; j++)
				stk.addLast(value);
			for (int j = 0; j < 10; j++)
				stk.removeLast();
		}
	}
}

public class StackExperiment extends Frame {

	public static void main (String [ ] args) {
		StackExperiment world = new StackExperiment(); world.show(); world.run(); }

	public StackExperiment () {
		setTitle("Stack Experiment with Deque");
		setSize(500, 300);
		add("Center", graph);
	}

	private GraphMaker graph = new GraphMaker(10000, 2500);

	public void run () {
		StackTester t1 = new StackTester(graph.getReporter("Deque"), 
				new IndexedDeque());
		t1.run(0, 10000, 200);
		StackTester t2 = new StackTester(graph.getReporter("Vector"), 
				new Vector());
		t2.run(0, 10000, 200);
	}
}

